"use strict";
this.name        = "stations_for_extra_planets_spotter"; 
this.author      = "spara"; 
this.copyright   = "2014 Mika Spara";
this.licence     = "CC BY-NC-SA 3.0"; 
this.description = "Visit 'em all, Collect 'em all"; 
this.version     = "1.0";

this.startUp = function() {
	if (!worldScripts.stations_for_extra_planets) {
		delete this.shipDockedWithStation;
		delete this.playerWillSaveGame;
		delete this.startUp;
		return;
	}
	if (!missionVariables.sfepArray) {
		this.$sfepArray = new Array();
	}
	else {
		this.$sfepArray = JSON.parse(missionVariables.sfepArray);
	}
	
	this.$totalNumberOfStations = worldScripts.stations_for_extra_planets.$corStations.length + worldScripts.stations_for_extra_planets.$dodStations.length + worldScripts.stations_for_extra_planets.$icoStations.length;
	this.$addSfepInterface();
};

this.shipDockedWithStation = function(station) {
	if (station.hasRole("sfep_station")) {
		var arrayElement = [station.name, station.dataKey, clock.clockString , system.name, system.info.galaxyID];
		var newSpot = 1;
		for (var i=0; i < this.$sfepArray.length; i++) {
			if (this.$sfepArray[i][1] === arrayElement[1]) {
				newSpot = 0;
				break;
			}
		}
		if (newSpot) {
			this.$sfepArray.push(arrayElement);
			this.$sfepArray.sort();
		}
	}
	this.$addSfepInterface();
};

this.$addSfepInterface = function() {
	player.ship.dockedStation.setInterface("sfep_spotter",{
		title: "Station spotter ("+this.$sfepArray.length+"/"+this.$totalNumberOfStations+" spotted)",
		category: "Statistical",
		summary: "Your collection of stations found orbiting secondary planets. Visit stations to collect them.",
		callback: this.$initSfepScreen.bind(this)
	});
};

this.$initSfepScreen = function() {
	if (this.$sfepArray.length > 0) {
		this.$showSfepStation(0);
	}
	else {
		mission.runScreen({
			title: "Station Spotter",
			message: "No stations collected yet, Commander.\n\nVisit 'em, Collect 'em!",
			background: "sfep_bg.png"
		});
	}
}

this.$showSfepStation = function(page) {
	if (page === this.$sfepArray.length) page = 0;
	else if (page === -1) page = this.$sfepArray.length - 1;
	var options = {
		"1_NEXT" : "Next",
		"2_PREVIOUS" : "Previous",
		"3_EXIT" : "Exit"
	};
	mission.runScreen({
		title: this.$sfepArray[page][0]+" ("+(page + 1)+"/"+this.$sfepArray.length+")",
		message: "Date: "+this.$sfepArray[page][2]+"\nSystem: "+this.$sfepArray[page][3]+"\nChart: "+(this.$sfepArray[page][4]+1),
		choices: options,
		model: "["+this.$sfepArray[page][1]+"]",
		background: "sfep_bg.png"
	},
	function (choice)
	{
		if (choice === "1_NEXT") this.$showSfepStation(page+1);
		else if (choice === "2_PREVIOUS") this.$showSfepStation(page-1);
	});
}

this.playerWillSaveGame = function () {
	missionVariables.sfepArray = JSON.stringify(this.$sfepArray);
}
